#include <windows.h>

#ifndef DLL_IOW24
#define DLL_IOW24

#define DLLEXPORT extern"C" __declspec(dllexport)

// dfinition du nombre d'entres  
const unsigned char nbentrees = 8;    // 8 entres
// Dfinition du nombre de sorties
const unsigned char nbsorties = 6;    // 6 sorties
// dfintion des entres et sorties
const unsigned char E_RD = 0;         //dfinition de constantes
const unsigned char E_sec = 1;        //pour les entres et sorties
const unsigned char E_min = 2;        //permettant une manipulation 
const unsigned char E_heu = 3;        //plus simple des pointeurs
const unsigned char E_dat = 4;        //POutput et PInput
const unsigned char E_moi = 5;
const unsigned char E_ann = 6;
const unsigned char E_init = 7;

const unsigned char S_sec = 0;
const unsigned char S_min = 1;
const unsigned char S_heu = 2;
const unsigned char S_dat = 3;
const unsigned char S_moi = 4;
const unsigned char S_ann = 5;




DLLEXPORT unsigned char _stdcall NumInputs();
DLLEXPORT unsigned char _stdcall NumOutputs();
DLLEXPORT void _stdcall GetInputName(unsigned char Channel,unsigned char *Name);
DLLEXPORT void _stdcall GetOutputName(unsigned char Channel,unsigned char *Name);
DLLEXPORT void _stdcall CSimStart(double *PInput, double *POutput, double *PUser);
DLLEXPORT void _stdcall CCalculate(double *PInput, double *POutput, double *PUser);
DLLEXPORT void _stdcall CSimStop(double *PInput, double *POutput, double *PUser);
DLLEXPORT void _stdcall CConfigure(double *PUser);

#endif
