/* Replace "dll.h" with the name of your header */
#include "dll.h"
#include "iowkit.h"
#include "fonction.cpp"

// Dfinition des variables
IOWKIT_HANDLE IOWarrior;



// Retourne le nombre d'entres 
DLLEXPORT unsigned char _stdcall NumInputs()
{
      return nbentrees;
}
  
// Retourne le nombre de sorties 
DLLEXPORT unsigned char _stdcall NumOutputs()
{
      return nbsorties;
}
  
// Retourne le nom des entres 
DLLEXPORT void _stdcall GetInputName(unsigned char Channel,unsigned char *Name)
{
     switch(Channel)
      {
         case 0 :
            Name[0]= 'R';
            Name[1]= 'D';
			Name[2]= 0;
            break; 
         case 1 :
            Name[0]= 's';
            Name[1]= 'e';
			Name[2]= 'c';
			Name[3]= 0;
            break; 
         case 2 :
            Name[0]= 'm';
            Name[1]= 'i';
			Name[2]= 'n';
			Name[3]= 0;
            break; 
         case 3 :
            Name[0]= 'h';
            Name[1]= 'e';
			Name[2]= 'u';
			Name[3]= 0;
            break; 
         case 4 :
            Name[0]= 'd';
            Name[1]= 'a';
			Name[2]= 't';
			Name[3]= 0;
            break; 
         case 5 :
            Name[0]= 'm';
            Name[1]= 'o';
			Name[2]= 'i';
			Name[3]= 0;
            break; 
         case 6 :
            Name[0]= 'a';
            Name[1]= 'n';
			Name[2]= 'n';
			Name[3]= 0;
            break; 
         case 7 :
            Name[0]= 'i';
            Name[1]= 'n';
			Name[2]= 'i';
			Name[3]= 't';
			Name[4]= 0;
            break; 
         default:;
	  }
}
  
// Retourne le nom des sorties 
DLLEXPORT void _stdcall GetOutputName(unsigned char Channel,unsigned char *Name)
{
 
      switch(Channel)
      {
         case 0 :
            Name[0]= 'S';
            Name[1]= 'E';
			Name[2]= 'C';
			Name[3]= 0;
			break;
         case 1 :
            Name[0]= 'M';
            Name[1]= 'I';
			Name[2]= 'N';
			Name[3]= 0;
            break; 
         case 2 :
            Name[0]= 'H';
            Name[1]= 'E';
			Name[2]= 'U';
			Name[3]= 0;
            break; 
         case 3 :
            Name[0]= 'D';
            Name[1]= 'A';
			Name[2]= 'T';
			Name[3]= 0;
            break; 
         case 4 :
            Name[0]= 'M';
            Name[1]= 'O';
			Name[2]= 'I';
			Name[3]= 0;
            break; 
         case 5 :
            Name[0]= 'A';
            Name[1]= 'N';
			Name[2]= 'N';
			Name[3]= 0;
            break; 
         default:;
	  }

}
  
// Retourne les conditions au dpart
DLLEXPORT void _stdcall CSimStart(double *PInput, double *POutput, double *PUser)
{     
      BOOLEAN rc;   
               
      // Open device
      IOWarrior = IowKitOpenDevice();
      if (IOWarrior == NULL)
          MessageBox(NULL,TEXT("Echec lors de l'ouverture de IOW24"),TEXT("Recherche IOW24"), MB_OK);     
      
      else
          MessageBox(NULL,TEXT("IOW24 dtect : initialisation de la liaison IC"),TEXT("Recherche IOW24"), MB_OK);
        
      rc = InitI2C(IOWarrior);
      if (!rc)
          MessageBox(NULL,TEXT("Echec pour initialiser l'I2C"),TEXT("Ecriture"), MB_OK);
}


  

// Lire les entres et crire sur la sortie
DLLEXPORT void _stdcall CCalculate(double *PInput, double *POutput, double *PUser)
{
      IOWKIT_SPECIAL_REPORT rapport_RTC;
      BOOLEAN rc;
      double Donnees;
      UCHAR dizaine, unite, i;
      //unsigned int i;
      
      if(PInput[E_init]>2.5)
           InitRTC(IOWarrior, PInput);
      else
      {
          if(PInput[E_RD]>2.5)
          {
              rapport_RTC = Lecture_heureRTC(IOWarrior);
              if(rapport_RTC.Bytes[0]>=0x80)
                   MessageBox(NULL,TEXT("Erreur de lecture"),TEXT("LECTURE"), MB_OK);
              else
              {
                  for (i=1;i<4;i++)
                       POutput[i-1] = bcd_vers_decimal(rapport_RTC.Bytes[i]);
              }
              rapport_RTC = Lecture_dateRTC(IOWarrior);
              if(rapport_RTC.Bytes[0]>=0x80)
                   MessageBox(NULL,TEXT("Erreur de lecture"),TEXT("LECTURE"), MB_OK);
              else
              {
                   for (i=1;i<4;i++)
                        POutput[i+2] = bcd_vers_decimal(rapport_RTC.Bytes[i]);
              }
         }   
      }
}
  
  
// Arrt du programme
DLLEXPORT void _stdcall CSimStop(double *PInput, double *POutput, double *PUser)
{
        BOOLEAN rc;

        rc = CloseI2C(IOWarrior);
        if (!rc)
             MessageBox(NULL,TEXT("Echec pour initialiser l'I2C"),TEXT("Ecriture"), MB_OK);
        // Close device
        IowKitCloseDevice(IOWarrior);

}

// Configuration du programme
DLLEXPORT void _stdcall CConfigure(double *PUser)
{
}

